/*
 File: angled_stringsym.cpp
 Date and Time: Fri Jan 30 18:55:04 2015 
*/
#include "angled_string.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_angled_string;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_angled_string::TH_angled_string(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_angled_string;
  NS_angled_string::Cangled_string Cangled_string_;// parallel-parser's parse table
#define ssPARSE_TABLE Cangled_string_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_angled_string::PROC_TH_angled_string(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_angled_string";
  static bool one_time(false);
  static NS_angled_string::Cangled_string* NS_angled_string_Cangled_string_(0);// parallel-parser's fsm table
  static Parser* NS_angled_string_Cangled_string_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_angled_string_Cangled_string_ = new NS_angled_string::Cangled_string();// parallel-parser's fsm table
    NS_angled_string_Cangled_string_parser = new Parser(*NS_angled_string_Cangled_string_,Caller_pp);
  }
 proc_parser = NS_angled_string_Cangled_string_parser;
#include "wproc_pp_core.h"
}
void 
Cangled_string::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rangled_string_:{
       Rangled_string* sym;
     if(re->rule_ == 0){
       sym = new Rangled_string(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rangled_string*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs1_Ropen_angle_:{
       Ropen_angle* sym;
     if(re->rule_ == 0){
       sym = new Ropen_angle(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_angle*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    default: return;
   }
}
